#include "opengl.h"
#include <GL/glut.h>
#define PI 3.14

pt3d_t *tabpoints=NULL;
pt3d_t *tabcolors=NULL;
int count;
double seuil = 8.0;

#define TRANSFORMATION 0


enum typemode
{
	points,
	lines,
	triangles,
	quads
};

int width;

void init_opengl(image_t *img_color,image_t *img_depth)
{
  /* ... Specify clear color (black) ... */
  glClearColor(0.0,0.0,0.0,0.0);
  /* ... Turn on depth testing (z-buffering) ... */
//  glEnable(GL_DEPTH_TEST);
//  glClearDepth(1.0);
  /* ... Turn on blending (for transparency) ... */
//  glEnable(GL_BLEND);
//  glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
	rx=5;
	ry=75;
	tz=80;
	yup=1;
//			// Z Buffer pour la suppression des parties cachées
		//glEnable(GL_DEPTH_TEST);
	//	glDisable(GL_DEPTH_TEST);
#if TRANSFORMATION
	rx=90;
	ry=-90;
	tz=80;
#else
	rx=90;
	ry=90;
	tz=80;
//	zc = 127*2+400;
//	tz = 127*2+400;	
#endif

	
//	if(img_color && img_depth)
//		Calcul(img_color,img_depth);
}
void DrawAxe()
{
	glColor3f(1.0,0.0,0.0);
	glRasterPos3f(10,0,0);
	glutBitmapCharacter(GLUT_BITMAP_HELVETICA_12,'X');
	glBegin(GL_LINES);
		glVertex3f(0,0,0);
		glVertex3f(10,0,0);
	glEnd();
	glColor3f(0.0,1.0,0.0);
	glRasterPos3f(0,10,0);
	glutBitmapCharacter(GLUT_BITMAP_HELVETICA_12,'Y');
	glBegin(GL_LINES);
		glVertex3f(0,0,0);
		glVertex3f(0,10,0);
	glEnd();
	glColor3f(0.0,0.0,1.0);
	glRasterPos3f(0,0,10);
	glutBitmapCharacter(GLUT_BITMAP_HELVETICA_12,'Z');
	glBegin(GL_LINES);
		glVertex3f(0,0,0);
		glVertex3f(0,0,10);
	glEnd();
}

void DrawGrille()
{
	int i,pas = 20;
	int max = 2000,min = -2000;
	glColor3f(0.8,0.8,0.8);
	// sur X
	for(i=min/2;i<max/2;i+=pas)
	{
		glBegin(GL_LINES);
			glVertex3f(i,0,min/2);
			glVertex3f(i,0,max/2);
		glEnd();
	}
	// sur Z
	for(i=min/2;i<max/2;i+=pas)
	{
		glBegin(GL_LINES);
			glVertex3f(min/2,0,i);
			glVertex3f(max/2,0,i);
		glEnd();
	}
}
void PosEye(double teta,double phi,double T)
{
	xe = T*sin(phi*PI/180)*cos(-teta*PI/180);
	ye = T*sin(phi*PI/180)*sin(-teta*PI/180);
	ze = T*cos(phi*PI/180);
}
void Mouse(int b,int s,int x,int y)
{
	// Initialisation position souris
	if(s==GLUT_DOWN)
	{
		switch(b)
		{
			case GLUT_LEFT_BUTTON:
				printf("bouton gauche appuyé\n");
				ButtonL = 1;
				break;
			case GLUT_RIGHT_BUTTON:
				printf("bouton droit appuyé\n");
				ButtonR = 1;
				break;
		}
	}
	else
	{
		printf("bouton relaché\n");
		ButtonL = 0;
		ButtonR = 0;
	}
}


pt3d_t Mult(pt3d_t vecteur,double d)
{
	pt3d_t v;
	double norme;
	/* Nome du vecteur */
	norme = sqrt(vecteur.x*vecteur.x + vecteur.y*vecteur.y + vecteur.z*vecteur.z);
	v.x =  vecteur.x / norme;
	v.y =  vecteur.y / norme;
	v.z =   vecteur.z / norme;
	v.x *= (d - vecteur.z);
	v.y *= (d - vecteur.z);
	v.z *= (d - vecteur.z);
	return v;
}
#define MIN(a,b) (a)<(b)?(a):(b)
void Calcul_Projection(image_t *img_color,image_t *img_depth)
{
	int x,y;
	int R,G,B,Zr,Zg,Zb;
	int i,j;
	double D = 400;
	double fact = 2;
	pt3d_t pt3d;
	int tabpoints_count = 0;	
	int tabcolors_count = 0;	
       if(tabpoints)
       {
           free(tabpoints);
	   tabpoints = NULL;
       }
       if(tabcolors)
       {
           free(tabcolors);
	   tabcolors = 0;
       }
//	seuil = 0.25;	
	width = img_color->width;
	/*Transformation sur l'image directement*/
	printf("Calcul de la projection 3D (%d %d)\n",img_depth->width,img_depth->height);
	for(y=0;y<img_depth->height;y++)
		for(x=0;x<img_depth->width;x++)
		{
			/* Récupération de la couleur */
			getpixel(img_color,x,y,&R,&G,&B);
			/* Récupération de la profondeur */
			getpixel(img_depth,x,y,&Zr,&Zg,&Zb);
			/*Si point vert*/
			if(Zr==0 && Zg==255 && Zb==0)
			{
				for(i=x ; ;i++)
	       			{
	          			getpixel_fast(img_depth,i,y,&Zr,&Zg,&Zb);
	          			if(!(Zr==0 && Zg == 255 && Zb == 0))
                     				break;
	       			}
	       			i = Zr;
	       			for(j=x ; ;j--)
	       			{
	          			getpixel_fast(img_depth,j,y,&Zr,&Zg,&Zb);
	          			if(!(Zr==0 && Zg == 255 && Zb == 0))
                     				break;
	       			}
	       			j = Zr;
	       			Zr = MIN(j,i);
			}			
			/* Construction du vecteur */
			/* Inversion des coordonnées => 
			 * origine image / image OpenGL*/
#if TRANSFORMATION
			pt3d.x = (1*img_depth->width/2.)-x;
			pt3d.y = y-(1*img_depth->height/2.);
			pt3d.z = (255-Zr/fact) + D;
			/* Calcul de la projection */
			pt3d = Mult(pt3d,D);
#else
			pt3d.x = (1*img_depth->width/2.)-x;
			pt3d.y = (1*img_depth->height/2.)-y;
			pt3d.z = (255-Zr*fact) + D;
#endif
			array_append(tabpoints,pt3d);
			/* Couleur */
			pt3d.x = R;
			pt3d.y = G;
			pt3d.z = B;
			array_append(tabcolors,pt3d);
		}		
	count = tabpoints_count;
	printf("taille : %d\n",count);
	printf("%d x %d\n",img_depth->width,img_depth->height);
#if 0
	printf("Calcul de la projection...\n");
        Image = CreateArray();^M
        for(i=0;i<img_carte->height;i++)
                for(j=0;j<img_carte->width;j++)
                {
                        /* Récupération de la couleur */
                        IplGetPixel(img_color,j,i,&R,&G,&B);
                        /* Récupération de la profondeur */
                        IplGetPixel(img_carte,j,i,&Z,&Z,&Z);
                        /* Construction du vecteur */
                        pt3d.x = j-img_color->width/2;^M
                        pt3d.y = i-img_color->height/2;^M
                        pt3d.z = (255-Z/fact) +D;
                        /* Calcul de la projection */
                        pt3d = Mult(pt3d,D);
                        Add(Image,pt3d.x,pt3d.y,pt3d.z);
                        SetColor(Image,Image->count-1,R,G,B);
                }
        printf("%d\n",GetCount(Image));
        printf("%d x %d =>%d\n",img_color->width,img_color->height,img_color->width*img_color->height);
#endif
}

void DrawPoints(pt3d_t *points,pt3d_t *colors,int count)
{
	int i;
	/* Affichage de points */
	for(i=0;i<count-1;i++)
	{
		glBegin(GL_POINTS);
			glColor3f(colors[i].x/255.,colors[i].y/255.,colors[i].z/255.);
			glVertex3f(points[i].x,points[i].y,points[i].z);
		glEnd();	
	}	
}

void DrawTriangle(pt3d_t *points,pt3d_t *colors,int count,int width,double seuil,int Mode)
{
	int i,pos;
	double min,max;
	/* Affichages des triangles */
	for(i=0;i< count-width ;i++)
	{
		//Fin de ligne horizontale 
		if(!((i)%(width+1)))
			continue;
		if(!((i+1)%(width+1)))
			continue;
		if(fabs(points[i].z - points[i+1].z) > seuil || fabs(points[i+1].z - points[i+width].z) > seuil )
		 continue;

		
		// Haut gauche
		
                if(fabs(points[i].x - points[i+1].x) > 20 || fabs(points[i+1].x - points[i+width].x) > 20)
		printf("%g %g %g => %d %d %d\n",points[i].x,points[1+i].x,points[i+width].x,i,1+i,i+width);
		
		 
		glBegin(Mode);
			pos = i;
			glColor3f(colors[pos].x/255.,colors[pos].y/255.,colors[pos].z/255.);
			glVertex3f(points[pos].x,points[pos].y,points[pos].z);
			
			pos = i+1;
			glColor3f(colors[pos].x/255.,colors[pos].y/255.,colors[pos].z/255.);
			glVertex3f(points[pos].x,points[pos].y,points[pos].z);
			
			pos = i+width;
			glColor3f(colors[pos].x/255.,colors[pos].y/255.,colors[pos].z/255.);
			glVertex3f(points[pos].x,points[pos].y,points[pos].z);
		glEnd();

		if(fabs(points[i+1].z - points[i+1+width].z) > seuil || fabs(points[i+1+width].z - points[i+width].z) > seuil )
		 continue;
		// Bas droite
		glBegin(Mode);
		
			pos = i+1;
			glColor3f(colors[pos].x/255.,colors[pos].y/255.,colors[pos].z/255.);
			glVertex3f(points[pos].x,points[pos].y,points[pos].z);
			
			pos = i+1+width;
			glColor3f(colors[pos].x/255.,colors[pos].y/255.,colors[pos].z/255.);
			glVertex3f(points[pos].x,points[pos].y,points[pos].z);
			
			pos = i+width;
			glColor3f(colors[pos].x/255.,colors[pos].y/255.,colors[pos].z/255.);
			glVertex3f(points[pos].x,points[pos].y,points[pos].z);
		glEnd();

	}
}

void DrawQuads(pt3d_t *points,pt3d_t *colors,int count,int width,double seuil)
{
	double min,max;
	int i,pos;
	/*Affichage de quads*/		
	for(i=0;i<count-width;i++)
	{
		//Fin de ligne horizontale 
	//	if(!((i+1)%(width)))
	//		continue;

		if(!((i)%(width+1)))
			continue;
		if(!((i+1)%(width+1)))
			continue;
	
		
		/*		min = MYMIN(	MYMIN(
						MYMIN(points[i].z,points[i+1].z),
						MYMIN(points[i+1].z,points[i+1+width].z)),
						MYMIN(points[i+1+width].z,points[i+width].z));
		max = MYMAX(	MYMAX(
						MYMAX(points[i].z,points[i+1].z),
						MYMAX(points[i+1].z,points[i+1+width].z)),
					MYMAX(points[i+1+width].z,points[i+width].z));
		if( (fabs(min)-fabs(max)) > seuil)
			continue;
*/

		if(fabs(points[i].z - points[i+1].z) > seuil || fabs(points[i+1].z - points[i+1+width].z) > seuil || 
		  fabs(points[i+1+width].z - points[i+width].z) > seuil || fabs(points[i+width].z - points[i].z) > seuil)
		 continue;
		
		glBegin(GL_QUADS);
			pos = i;
			//R = fabs(GetElemZ(Image,pos))/255.;
			//G = fabs(GetElemZ(Image,pos))/255.;
			//B = fabs(GetElemZ(Image,pos))/255.;
			glColor3f(colors[pos].x/255.,colors[pos].y/255.,colors[pos].z/255.);
			//glColor3f(R,G,B);
			glVertex3f(points[pos].x,points[pos].y,points[pos].z);

			pos = i+1;
			//R = fabs(GetElemZ(Image,pos))/255.;
			//G = fabs(GetElemZ(Image,pos))/255.;
			//B = fabs(GetElemZ(Image,pos))/255.;
			glColor3f(colors[pos].x/255.,colors[pos].y/255.,colors[pos].z/255.);
			glVertex3f(points[pos].x,points[pos].y,points[pos].z);
	
			pos = i+1+width;
			//R = fabs(GetElemZ(Image,pos))/255.;
			//G = fabs(GetElemZ(Image,pos))/255.;
			//B = fabs(GetElemZ(Image,pos))/255.;
			glColor3f(colors[pos].x/255.,colors[pos].y/255.,colors[pos].z/255.);
			glVertex3f(points[pos].x,points[pos].y,points[pos].z);
	
			pos = i+width;
			//R = fabs(GetElemZ(Image,pos))/255.;
			//G = fabs(GetElemZ(Image,pos))/255.;
			//B = fabs(GetElemZ(Image,pos))/255.;
			glColor3f(colors[pos].x/255.,colors[pos].y/255.,colors[pos].z/255.);
			glVertex3f(points[pos].x,points[pos].y,points[pos].z);
		glEnd();
	}		
}

void DrawScene(void)
{
	seuil = 8.0;
	switch(Mode)
	{
		case points:
			DrawPoints(tabpoints,tabcolors,count);
			break;
		case lines:
			DrawTriangle(tabpoints,tabcolors,count,width,seuil,GL_LINE_LOOP);
			break;
		case triangles:
			DrawTriangle(tabpoints,tabcolors,count,width,seuil,GL_TRIANGLES);
			break;
		case quads:
			DrawQuads(tabpoints,tabcolors,count,width,seuil);
			break;
	}	
}
