#include "opengl.h"
#include <string.h>
#include <stdio.h>
#include <math.h>
#include "main.h"
#include "image.h"



int Taille = 500;

void clavier(unsigned char key, int x, int y);
void clavier3dspe(int key, int x, int y);
void Mouse(int b,int s,int x,int y);
void MouseMove(int x,int y);
void display(void);
void reshape (GLsizei w, GLsizei h);

void DrawScene(void);

void Calcul_Projection(image_t *img_color,image_t *img_depth);

opengl_t glwin;

pt3d_t *tabpoints=NULL;
pt3d_t *tabcolors=NULL;
int count;

int Mode;

enum typemode
{
	points,
	lines,
	triangles,
	quads
};

double seuil = 8.0;
int width;

void OpenGL_Carte3d(image_t *img_color,image_t *img_depth)
{
	seuil = 1000;	
	width = img_color->width;

	Calcul_Projection(img_color,img_depth);

	glwin.angle.rx=90;
	glwin.angle.ry=-100;
	glwin.angle.tz=800;
	glwin.up.y = 1;

	PosEye(glwin.angle,&glwin.eye);
	
	
	glwin.width = Taille;
	glwin.height = Taille;
	strcpy(glwin.title,"3D");
		

	glwin.gl_keyboard = clavier;
	glwin.gl_keyboardspe = clavier3dspe;
	glwin.gl_mouse = Mouse;
	glwin.gl_mousemove = MouseMove;
	glwin.gl_display = display;
	glwin.gl_reshape = reshape;

	init_glwin(glwin);
}

void clavier(unsigned char key, int x, int y)
{
	switch(key)
	{
		case 'm':
			Mode = (Mode+1)%4;
			break;
		case '+':
			seuil += 0.5;		
			break;
		case '-':
			seuil -= 0.5;		
			break;
		case 'f':
			glutFullScreen();		
			break;
		case 27:
			exit(0);
			break;
	}
	glutPostRedisplay();
}
void clavier3dspe(int key, int x, int y)
{
	switch (key) 
	{
		case GLUT_KEY_UP :
			if(glutGetModifiers() == GLUT_ACTIVE_CTRL)
				glwin.center.y -= 10;
			else
				glwin.center.z += 10;
			break; 
		case GLUT_KEY_DOWN :
			if(glutGetModifiers() == GLUT_ACTIVE_CTRL)
				glwin.center.y += 10;
			else
				glwin.center.z -= 10;
			break; 
		case GLUT_KEY_RIGHT :
			glwin.center.x += 10;
			break; 
		case GLUT_KEY_LEFT :
			glwin.center.x -= 10;
			break; 
	}
	glutPostRedisplay();

}
void Mouse(int b,int s,int x,int y)
{
	// Initialisation position souris
	if(s==GLUT_DOWN)
	{
		switch(b)
		{
			case GLUT_LEFT_BUTTON:
				glwin.mbutton[LBUTTON].state = pushed;
				break;
			case GLUT_RIGHT_BUTTON:
				glwin.mbutton[RBUTTON].state = pushed;
				break;
			case GLUT_MIDDLE_BUTTON:
				glwin.mbutton[MBUTTON].state = pushed;
				break;
		}
	}
	else
	{
		glwin.mbutton[LBUTTON].state = released;
		glwin.mbutton[RBUTTON].state = released;
		glwin.mbutton[MBUTTON].state = released;
	}
}
void MouseMove(int x,int y)
{
	if(glwin.mbutton[LBUTTON].state==pushed || glwin.mbutton[RBUTTON].state == pushed || glwin.mbutton[MBUTTON].state == pushed)
	{
		int test=0;
		if(glwin.mbutton[LBUTTON].state == pushed)
		{
			if(fabs(glwin.mcoord.x-x) > 0.1)
			{
				if(x<glwin.mcoord.x)
					glwin.angle.rx-=1;
				else
					glwin.angle.rx+=1;
			}
			if(fabs(glwin.mcoord.y-y) > 0.1)
			{
				if(y<glwin.mcoord.y)
					glwin.angle.ry-=1;
				else
					glwin.angle.ry+=1;
			}
		}
		else if(glwin.mbutton[RBUTTON].state==pushed)
		{
			if(y<glwin.mcoord.y)
				glwin.angle.tz+=4;
			else
				glwin.angle.tz-=4;
		}
		else if(glwin.mbutton[MBUTTON].state == pushed)
		{
			if(x<glwin.mcoord.x)
				glwin.center.x+=2;
			else
				glwin.center.x-=2;	
			if(y<glwin.mcoord.y)
				glwin.center.z+=2;
			else
				glwin.center.z-=2;	
		}
		// Mise à jour position souris
		glwin.mcoord.x = x;
		glwin.mcoord.y = y;
		
		if(glwin.angle.ry<0)
			test = (int)(fabs(glwin.angle.ry-180)/180)%2;
		if(glwin.angle.ry>0)
			test = (int)(glwin.angle.ry/180)%2;
		if(test)
			glwin.up.y = +1;
		else
			glwin.up.y = -1;
		// Calcul de la position de l''oeil
		PosEye(glwin.angle,&glwin.eye);
		glutPostRedisplay();
	}
}
void display(void)
{
	glViewport ( 0, 0, glwin.width, glwin.height);
	glMatrixMode (GL_PROJECTION);
	glLoadIdentity ();
	gluPerspective(	45.0,					// field of view in degree 
			(double)glwin.width/(double)glwin.height,			// aspect ratio 
			1,				// Z near 
			10000.0); 		// Z far 
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(	glwin.eye.x+glwin.center.x, -glwin.eye.z+glwin.center.y, glwin.eye.y+glwin.center.z,		// eye    
			glwin.center.x,glwin.center.y,glwin.center.z,							// center 
			glwin.up.x,glwin.up.y,glwin.up.z);					// up is in positive Y direction 

	glClearColor(1,1,1, 1);        
	glClear (GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

	glPushAttrib(GL_POINT_BIT);
	glColor3f(0,0,0);
	glPointSize(3);
		glBegin(GL_POINTS);
		glVertex3f(glwin.center.x,glwin.center.y,glwin.center.z);
		glEnd();
	glPopAttrib();

	DrawScene();
	DrawAxe();
	DrawGrille();

	glFlush();
	glutSwapBuffers();
	if(glGetError() != GL_NO_ERROR)
		printf("erreur opengl\n");

}
void reshape (GLsizei w, GLsizei h)
{
	glwin.width = w;
	glwin.height = h;
	glutPostRedisplay();
}

pt3d_t Mult(pt3d_t vecteur,double d)
{
	pt3d_t v;
	double norme;
	/* Nome du vecteur */
	norme = sqrt(vecteur.x*vecteur.x + vecteur.y*vecteur.y + vecteur.z*vecteur.z);
	v.x =  vecteur.x / norme;
	v.y =  vecteur.y / norme;
	v.z =   vecteur.z / norme;
	v.x *= (d - vecteur.z);
	v.y *= (d - vecteur.z);
	v.z *= (d - vecteur.z);
	return v;
}

void Calcul_Projection(image_t *img_color,image_t *img_depth)
{
	int x,y;
	int R,G,B,Z;
	double D = 400;
	double fact = 2;
	pt3d_t pt3d;
	int tabpoints_count = 0;	
	int tabcolors_count = 0;	
	/*Transformation sur l'image directement*/
	printf("Calcul de la projection 3D (%d %d)\n",img_depth->width,img_depth->height);
	for(y=0;y<img_depth->height;y++)
		for(x=0;x<img_depth->width;x++)
		{
			/* Récupération de la couleur */
			getpixel(img_color,x,y,&R,&G,&B);
			/* Récupération de la profondeur */
			getpixel(img_depth,x,y,&Z,&Z,&Z);
			/* Construction du vecteur */
			pt3d.x = x-(1*img_depth->width/2.);
			pt3d.y = y-(1*img_depth->height/2.);
			pt3d.z = (255-Z/fact) +D;
			/* Calcul de la projection */
			pt3d = Mult(pt3d,D);
			array_append(tabpoints,pt3d);
			/* Couleur */
			pt3d.x = R;
			pt3d.y = G;
			pt3d.z = B;
			array_append(tabcolors,pt3d);
		}		
	count = tabpoints_count;
}

void DrawPoints(pt3d_t *points,pt3d_t *colors,int count)
{
	int i;
	/* Affichage de points */
	for(i=0;i<count-1;i++)
	{
		glBegin(GL_POINTS);
			glColor3f(colors[i].x/255.,colors[i].y/255.,colors[i].z/255.);
			glVertex3f(points[i].x,points[i].y,points[i].z);
		glEnd();	
	}	
}

void DrawTriangle(pt3d_t *points,pt3d_t *colors,int count,int width,double seuil,int Mode)
{
	int i,pos;
	double min,max;
	/* Affichages des triangles */
	for(i=0;i<count-width;i++)
	{
		//Fin de ligne horizontale 
		if(!((i+1)%(width)))
			continue;
		min = MIN(MIN(points[i].z,points[i+1].z) ,MIN(points[i+1].z,points[i+width].z));
		max = MAX(MAX(points[i].z,points[i+1].z) ,MAX(points[i+1].z,points[i+width].z));
		if( (fabs(min)-fabs(max)) > seuil)
			continue;
		// Haut gauche
		glBegin(Mode);
			pos = i;
			glColor3f(colors[pos].x/255.,colors[pos].y/255.,colors[pos].z/255.);
			glVertex3f(points[pos].x,points[pos].y,points[pos].z);
			
			pos = i+1;
			glColor3f(colors[pos].x/255.,colors[pos].y/255.,colors[pos].z/255.);
			glVertex3f(points[pos].x,points[pos].y,points[pos].z);
			
			pos = i+width;
			glColor3f(colors[pos].x/255.,colors[pos].y/255.,colors[pos].z/255.);
			glVertex3f(points[pos].x,points[pos].y,points[pos].z);
		glEnd();

		min = MIN(MIN(points[i+1].z,points[i+1+width].z) ,MIN(points[i+1+width].z,points[i+width].z));
		max = MAX(MAX(points[i+1].z,points[i+1+width].z) ,MAX(points[i+1+width].z,points[i+width].z));		
		if( (fabs(min)-fabs(max)) > seuil)
			continue;
		// Bas droite
		glBegin(Mode);
		
			pos = i+1;
			glColor3f(colors[pos].x/255.,colors[pos].y/255.,colors[pos].z/255.);
			glVertex3f(points[pos].x,points[pos].y,points[pos].z);
			
			pos = i+1+width;
			glColor3f(colors[pos].x/255.,colors[pos].y/255.,colors[pos].z/255.);
			glVertex3f(points[pos].x,points[pos].y,points[pos].z);
			
			pos = i+width;
			glColor3f(colors[pos].x/255.,colors[pos].y/255.,colors[pos].z/255.);
			glVertex3f(points[pos].x,points[pos].y,points[pos].z);
		glEnd();
	}
}

void DrawQuads(pt3d_t *points,pt3d_t *colors,int count,int width,double seuil)
{
	double min,max;
	int i,pos;
	/*Affichage de quads*/		
	for(i=0;i<count-width;i++)
	{
		//Fin de ligne horizontale 
		if(!((i+1)%(width)))
			continue;
		min = MIN(	MIN(
						MIN(points[i].z,points[i+1].z),
						MIN(points[i+1].z,points[i+1+width].z)),
						MIN(points[i+1+width].z,points[i+width].z));
		max = MAX(	MAX(
						MAX(points[i].z,points[i+1].z),
						MAX(points[i+1].z,points[i+1+width].z)),
					MAX(points[i+1+width].z,points[i+width].z));
		if( (fabs(min)-fabs(max)) > seuil)
			continue;
		glBegin(GL_QUADS);
			pos = i;
			//R = fabs(GetElemZ(Image,pos))/255.;
			//G = fabs(GetElemZ(Image,pos))/255.;
			//B = fabs(GetElemZ(Image,pos))/255.;
			glColor3f(colors[pos].x/255.,colors[pos].y/255.,colors[pos].z/255.);
			//glColor3f(R,G,B);
			glVertex3f(points[pos].x,points[pos].y,points[pos].z);

			pos = i+1;
			//R = fabs(GetElemZ(Image,pos))/255.;
			//G = fabs(GetElemZ(Image,pos))/255.;
			//B = fabs(GetElemZ(Image,pos))/255.;
			glColor3f(colors[pos].x/255.,colors[pos].y/255.,colors[pos].z/255.);
			glVertex3f(points[pos].x,points[pos].y,points[pos].z);
	
			pos = i+1+width;
			//R = fabs(GetElemZ(Image,pos))/255.;
			//G = fabs(GetElemZ(Image,pos))/255.;
			//B = fabs(GetElemZ(Image,pos))/255.;
			glColor3f(colors[pos].x/255.,colors[pos].y/255.,colors[pos].z/255.);
			glVertex3f(points[pos].x,points[pos].y,points[pos].z);
	
			pos = i+width;
			//R = fabs(GetElemZ(Image,pos))/255.;
			//G = fabs(GetElemZ(Image,pos))/255.;
			//B = fabs(GetElemZ(Image,pos))/255.;
			glColor3f(colors[pos].x/255.,colors[pos].y/255.,colors[pos].z/255.);
			glVertex3f(points[pos].x,points[pos].y,points[pos].z);
		glEnd();
	}		
}

void DrawScene(void)
{
	switch(Mode)
	{
		case points:
			DrawPoints(tabpoints,tabcolors,count);
			break;
		case lines:
			DrawTriangle(tabpoints,tabcolors,count,width,seuil,GL_LINE_LOOP);
			break;
		case triangles:
			DrawTriangle(tabpoints,tabcolors,count,width,seuil,GL_TRIANGLES);
			break;
		case quads:
			DrawQuads(tabpoints,tabcolors,count,width,seuil);
			break;
	}	
}
